# coding: utf-8

# flake8: noqa

"""
    h2oGPTe REST API

     # Overview   Users can easily interact with the h2oGPTe API through its REST API, allowing HTTP requests from any programming language.  ## Authorization: Getting an API key  Sign up/in at Enterprise h2oGPTe and generate one of the following two types of API keys:   - **Global API key**: If a Collection is not specified when creating a new API Key, that key is considered to be a global API Key. Use global API Keys to grant full user impersonation and system-wide access to all of your work. Anyone with access to one of your global API Keys can create, delete, or interact with any of your past, current, and future Collections, Documents, Chats, and settings.  - **Collection-specific API key**: Use Collection-specific API Keys to grant external access to only Chat with a specified Collection and make related API calls to it. Collection-specific API keys do not allow other API calls, such as creation, deletion, or access to other Collections or Chats.   Access Enterprise h2oGPTe through your [H2O Generative AI](https://genai.h2o.ai/appstore) app store account, available with a freemium tier.  ## Authorization: Using an API key   All h2oGPTe REST API requests must include an API Key in the \"Authorization\" HTTP header, formatted as follows:  ``` Authorization: Bearer sk-XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX ```  ```sh curl -X 'POST' \\   'https://h2ogpte.genai.h2o.ai/api/v1/collections' \\   -H 'accept: application/json' \\   -H 'Content-Type: application/json' \\   -H 'Authorization: Bearer sk-XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX' \\   -d '{     \"name\": \"The name of my Collection\",     \"description\": \"The description of my Collection\",     \"embedding_model\": \"BAAI/bge-large-en-v1.5\"   }' ```      ## Interactive h2oGPTe API testing  This page only showcases the h2oGPTe REST API; you can test it directly in the [Swagger UI](https://h2ogpte.genai.h2o.ai/swagger-ui/). Ensure that you are logged into your Enterprise h2oGPTe account. 

    The version of the OpenAPI document: v1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.6.33"

# import apis into sdk package
from h2ogpte.rest_async.api.api_keys_api import APIKeysApi
from h2ogpte.rest_async.api.agents_api import AgentsApi
from h2ogpte.rest_async.api.chat_api import ChatApi
from h2ogpte.rest_async.api.collections_api import CollectionsApi
from h2ogpte.rest_async.api.configurations_api import ConfigurationsApi
from h2ogpte.rest_async.api.document_ingestion_api import DocumentIngestionApi
from h2ogpte.rest_async.api.documents_api import DocumentsApi
from h2ogpte.rest_async.api.jobs_api import JobsApi
from h2ogpte.rest_async.api.models_api import ModelsApi
from h2ogpte.rest_async.api.permissions_api import PermissionsApi
from h2ogpte.rest_async.api.prompt_templates_api import PromptTemplatesApi
from h2ogpte.rest_async.api.system_api import SystemApi
from h2ogpte.rest_async.api.tags_api import TagsApi

# import ApiClient
from h2ogpte.rest_async.api_response import ApiResponse
from h2ogpte.rest_async.api_client import ApiClient
from h2ogpte.rest_async.configuration import Configuration
from h2ogpte.rest_async.exceptions import OpenApiException
from h2ogpte.rest_async.exceptions import ApiTypeError
from h2ogpte.rest_async.exceptions import ApiValueError
from h2ogpte.rest_async.exceptions import ApiKeyError
from h2ogpte.rest_async.exceptions import ApiAttributeError
from h2ogpte.rest_async.exceptions import ApiException

# import models into sdk package
from h2ogpte.rest_async.models.api_key_create_request import APIKeyCreateRequest
from h2ogpte.rest_async.models.api_key_info import APIKeyInfo
from h2ogpte.rest_async.models.api_key_result import APIKeyResult
from h2ogpte.rest_async.models.api_key_update_expiry_request import APIKeyUpdateExpiryRequest
from h2ogpte.rest_async.models.agent_key import AgentKey
from h2ogpte.rest_async.models.agent_server_directory_file_stats import AgentServerDirectoryFileStats
from h2ogpte.rest_async.models.agent_server_directory_stats import AgentServerDirectoryStats
from h2ogpte.rest_async.models.agent_server_directory_stats_per_agent_chat_session import AgentServerDirectoryStatsPerAgentChatSession
from h2ogpte.rest_async.models.agent_server_file import AgentServerFile
from h2ogpte.rest_async.models.agent_tool_key_associations import AgentToolKeyAssociations
from h2ogpte.rest_async.models.agent_tool_spec import AgentToolSpec
from h2ogpte.rest_async.models.agent_tool_spec_api_keys import AgentToolSpecApiKeys
from h2ogpte.rest_async.models.azure_credentials import AzureCredentials
from h2ogpte.rest_async.models.chat_completion import ChatCompletion
from h2ogpte.rest_async.models.chat_completion_delta import ChatCompletionDelta
from h2ogpte.rest_async.models.chat_completion_request import ChatCompletionRequest
from h2ogpte.rest_async.models.chat_error import ChatError
from h2ogpte.rest_async.models.chat_message import ChatMessage
from h2ogpte.rest_async.models.chat_message_meta import ChatMessageMeta
from h2ogpte.rest_async.models.chat_message_reference import ChatMessageReference
from h2ogpte.rest_async.models.chat_session import ChatSession
from h2ogpte.rest_async.models.chat_session_update_request import ChatSessionUpdateRequest
from h2ogpte.rest_async.models.chat_settings import ChatSettings
from h2ogpte.rest_async.models.chunk import Chunk
from h2ogpte.rest_async.models.chunk_search_result import ChunkSearchResult
from h2ogpte.rest_async.models.collection import Collection
from h2ogpte.rest_async.models.collection_change_request import CollectionChangeRequest
from h2ogpte.rest_async.models.collection_create_request import CollectionCreateRequest
from h2ogpte.rest_async.models.collection_settings import CollectionSettings
from h2ogpte.rest_async.models.collection_update_request import CollectionUpdateRequest
from h2ogpte.rest_async.models.count import Count
from h2ogpte.rest_async.models.count_with_queue_details import CountWithQueueDetails
from h2ogpte.rest_async.models.create_agent_key_request import CreateAgentKeyRequest
from h2ogpte.rest_async.models.create_agent_tool_key_associations_request import CreateAgentToolKeyAssociationsRequest
from h2ogpte.rest_async.models.create_import_collection_to_collection_job_request import CreateImportCollectionToCollectionJobRequest
from h2ogpte.rest_async.models.create_insert_document_to_collection_job_request import CreateInsertDocumentToCollectionJobRequest
from h2ogpte.rest_async.models.create_topic_model_job_request import CreateTopicModelJobRequest
from h2ogpte.rest_async.models.delete_chat_sessions_job_request import DeleteChatSessionsJobRequest
from h2ogpte.rest_async.models.delete_collections_job_request import DeleteCollectionsJobRequest
from h2ogpte.rest_async.models.delete_documents_job_request import DeleteDocumentsJobRequest
from h2ogpte.rest_async.models.delete_tag_from_document200_response import DeleteTagFromDocument200Response
from h2ogpte.rest_async.models.document import Document
from h2ogpte.rest_async.models.document_summary import DocumentSummary
from h2ogpte.rest_async.models.document_update_request import DocumentUpdateRequest
from h2ogpte.rest_async.models.embedding_model import EmbeddingModel
from h2ogpte.rest_async.models.encode_chunks_for_retrieval_request import EncodeChunksForRetrievalRequest
from h2ogpte.rest_async.models.endpoint_error import EndpointError
from h2ogpte.rest_async.models.extraction_request import ExtractionRequest
from h2ogpte.rest_async.models.gcs_credentials import GCSCredentials
from h2ogpte.rest_async.models.global_configuration_item import GlobalConfigurationItem
from h2ogpte.rest_async.models.group_create_request import GroupCreateRequest
from h2ogpte.rest_async.models.group_info import GroupInfo
from h2ogpte.rest_async.models.guardrails_settings import GuardrailsSettings
from h2ogpte.rest_async.models.guardrails_settings_create_request import GuardrailsSettingsCreateRequest
from h2ogpte.rest_async.models.h2_ogptgpu_info import H2OGPTGPUInfo
from h2ogpte.rest_async.models.h2_ogpt_system_info import H2OGPTSystemInfo
from h2ogpte.rest_async.models.ingest_from_azure_blob_storage_body import IngestFromAzureBlobStorageBody
from h2ogpte.rest_async.models.ingest_from_file_system_body import IngestFromFileSystemBody
from h2ogpte.rest_async.models.ingest_from_gcs_body import IngestFromGcsBody
from h2ogpte.rest_async.models.ingest_from_s3_body import IngestFromS3Body
from h2ogpte.rest_async.models.ingest_from_website_body import IngestFromWebsiteBody
from h2ogpte.rest_async.models.ingest_upload_body import IngestUploadBody
from h2ogpte.rest_async.models.job_details import JobDetails
from h2ogpte.rest_async.models.job_details_status import JobDetailsStatus
from h2ogpte.rest_async.models.key_association import KeyAssociation
from h2ogpte.rest_async.models.match_collection_chunks_request import MatchCollectionChunksRequest
from h2ogpte.rest_async.models.message_vote_update_request import MessageVoteUpdateRequest
from h2ogpte.rest_async.models.model import Model
from h2ogpte.rest_async.models.model_answer import ModelAnswer
from h2ogpte.rest_async.models.model_extraction_answer import ModelExtractionAnswer
from h2ogpte.rest_async.models.model_usage_stats_per_user import ModelUsageStatsPerUser
from h2ogpte.rest_async.models.new_key_association import NewKeyAssociation
from h2ogpte.rest_async.models.performance_stats_per_model import PerformanceStatsPerModel
from h2ogpte.rest_async.models.permission_check_request import PermissionCheckRequest
from h2ogpte.rest_async.models.permission_reset_request import PermissionResetRequest
from h2ogpte.rest_async.models.process_document_job_request import ProcessDocumentJobRequest
from h2ogpte.rest_async.models.prompt_template import PromptTemplate
from h2ogpte.rest_async.models.prompt_template_base import PromptTemplateBase
from h2ogpte.rest_async.models.prompt_template_change_request import PromptTemplateChangeRequest
from h2ogpte.rest_async.models.prompt_template_create_request import PromptTemplateCreateRequest
from h2ogpte.rest_async.models.qa_feedback import QAFeedback
from h2ogpte.rest_async.models.question_request import QuestionRequest
from h2ogpte.rest_async.models.queue_details import QueueDetails
from h2ogpte.rest_async.models.reset_and_share_prompt_template_request import ResetAndSharePromptTemplateRequest
from h2ogpte.rest_async.models.role_create_request import RoleCreateRequest
from h2ogpte.rest_async.models.role_info import RoleInfo
from h2ogpte.rest_async.models.roles_reset_request import RolesResetRequest
from h2ogpte.rest_async.models.s3_credentials import S3Credentials
from h2ogpte.rest_async.models.search_collection_chunks_request import SearchCollectionChunksRequest
from h2ogpte.rest_async.models.self_test_result import SelfTestResult
from h2ogpte.rest_async.models.set_collection_size_limit_request import SetCollectionSizeLimitRequest
from h2ogpte.rest_async.models.set_global_configuration_request import SetGlobalConfigurationRequest
from h2ogpte.rest_async.models.set_user_configuration_request import SetUserConfigurationRequest
from h2ogpte.rest_async.models.share_collection_request import ShareCollectionRequest
from h2ogpte.rest_async.models.share_permission import SharePermission
from h2ogpte.rest_async.models.suggested_question import SuggestedQuestion
from h2ogpte.rest_async.models.summarize_request import SummarizeRequest
from h2ogpte.rest_async.models.tag import Tag
from h2ogpte.rest_async.models.tag_create_request import TagCreateRequest
from h2ogpte.rest_async.models.tag_update_request import TagUpdateRequest
from h2ogpte.rest_async.models.update_agent_key_request import UpdateAgentKeyRequest
from h2ogpte.rest_async.models.update_agent_tool_preference_request import UpdateAgentToolPreferenceRequest
from h2ogpte.rest_async.models.update_collection_expiry_date_request import UpdateCollectionExpiryDateRequest
from h2ogpte.rest_async.models.update_collection_inactivity_interval_request import UpdateCollectionInactivityIntervalRequest
from h2ogpte.rest_async.models.update_collection_privacy_request import UpdateCollectionPrivacyRequest
from h2ogpte.rest_async.models.update_qa_feedback_request import UpdateQAFeedbackRequest
from h2ogpte.rest_async.models.uploaded_file import UploadedFile
from h2ogpte.rest_async.models.usage_stats import UsageStats
from h2ogpte.rest_async.models.usage_stats_per_model import UsageStatsPerModel
from h2ogpte.rest_async.models.usage_stats_per_model_and_user import UsageStatsPerModelAndUser
from h2ogpte.rest_async.models.usage_stats_per_user import UsageStatsPerUser
from h2ogpte.rest_async.models.user_configuration_item import UserConfigurationItem
from h2ogpte.rest_async.models.user_info import UserInfo
from h2ogpte.rest_async.models.user_job_details import UserJobDetails
from h2ogpte.rest_async.models.user_permission import UserPermission
