# coding: utf-8

"""
    h2oGPTe REST API

     # Overview   Users can easily interact with the h2oGPTe API through its REST API, allowing HTTP requests from any programming language.  ## Authorization: Getting an API key  Sign up/in at Enterprise h2oGPTe and generate one of the following two types of API keys:   - **Global API key**: If a Collection is not specified when creating a new API Key, that key is considered to be a global API Key. Use global API Keys to grant full user impersonation and system-wide access to all of your work. Anyone with access to one of your global API Keys can create, delete, or interact with any of your past, current, and future Collections, Documents, Chats, and settings.  - **Collection-specific API key**: Use Collection-specific API Keys to grant external access to only Chat with a specified Collection and make related API calls to it. Collection-specific API keys do not allow other API calls, such as creation, deletion, or access to other Collections or Chats.   Access Enterprise h2oGPTe through your [H2O Generative AI](https://genai.h2o.ai/appstore) app store account, available with a freemium tier.  ## Authorization: Using an API key   All h2oGPTe REST API requests must include an API Key in the \"Authorization\" HTTP header, formatted as follows:  ``` Authorization: Bearer sk-XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX ```  ```sh curl -X 'POST' \\   'https://h2ogpte.genai.h2o.ai/api/v1/collections' \\   -H 'accept: application/json' \\   -H 'Content-Type: application/json' \\   -H 'Authorization: Bearer sk-XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX' \\   -d '{     \"name\": \"The name of my Collection\",     \"description\": \"The description of my Collection\",     \"embedding_model\": \"BAAI/bge-large-en-v1.5\"   }' ```      ## Interactive h2oGPTe API testing  This page only showcases the h2oGPTe REST API; you can test it directly in the [Swagger UI](https://h2ogpte.genai.h2o.ai/swagger-ui/). Ensure that you are logged into your Enterprise h2oGPTe account. 

    The version of the OpenAPI document: v1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from h2ogpte.rest_sync.models.guardrails_settings import GuardrailsSettings
from typing import Optional, Set
from typing_extensions import Self

class CollectionSettings(BaseModel):
    """
    CollectionSettings
    """ # noqa: E501
    max_tokens_per_chunk: Optional[StrictInt] = Field(default=None, description="Approximate max. number of tokens per chunk for text-dominated document pages. For images, chunks can be larger.")
    chunk_overlap_tokens: Optional[StrictInt] = Field(default=None, description="Approximate number of tokens that are overlapping between successive chunks.")
    gen_doc_summaries: Optional[StrictBool] = Field(default=False, description="Whether to auto-generate document summaries (uses LLM)")
    gen_doc_questions: Optional[StrictBool] = Field(default=False, description="Whether to auto-generate sample questions for each document (uses LLM)")
    audio_input_language: Optional[StrictStr] = Field(default='auto', description="Language of audio files. Defaults to \"auto\" language detection. Pass empty string to see choices.")
    ocr_model: Optional[StrictStr] = Field(default='auto', description="Which method to use to extract text from images using AI-enabled optical character recognition (OCR) models. Pass empty string to see choices. docTR is best for Latin text, PaddleOCR is best for certain non-Latin languages, Tesseract covers a wide range of languages. Mississippi works well on handwriting. auto - Automatic will auto-select the best OCR model for every page. off - Disable OCR for speed, but all images will then be skipped (also no image captions will be made).")
    tesseract_lang: Optional[StrictStr] = Field(default=None, description="Which language to use when using ocr_model=\"tesseract\". Pass empty string to see choices.")
    keep_tables_as_one_chunk: Optional[StrictBool] = Field(default=None, description="When tables are identified by the table parser the table tokens will be kept in a single chunk.")
    chunk_by_page: Optional[StrictBool] = Field(default=None, description="Each page will be a chunk. `keep_tables_as_one_chunk` will be ignored if this is `true`.")
    handwriting_check: Optional[StrictBool] = Field(default=None, description="Check pages for handwriting. Will use specialized models if handwriting is found.")
    follow_links: Optional[StrictBool] = Field(default=None, description="Whether to import all web pages linked from this URL will be imported. External links will be ignored. Links to other pages on the same domain will be followed as long as they are at the same level or below the URL you specify. Each page will be transformed into a PDF document.")
    max_depth: Optional[StrictInt] = Field(default=None, description="Max depth of recursion when following links, only when follow_links is `true`. Max_depth of 0 means don't follow any links, max_depth of 1 means follow only top-level links, etc. Use -1 for automatic (system settings).")
    max_documents: Optional[StrictInt] = Field(default=None, description="Max number of documents when following links, only when follow_links is `true`. Use None for automatic (system defaults). Use -1 for max (system limit).")
    root_dir: Optional[StrictStr] = Field(default=None, description="Root directory for document storage")
    copy_document: Optional[StrictBool] = Field(default=None, description="Whether to copy the document when importing an existing document")
    guardrails_settings: Optional[GuardrailsSettings] = None
    __properties: ClassVar[List[str]] = ["max_tokens_per_chunk", "chunk_overlap_tokens", "gen_doc_summaries", "gen_doc_questions", "audio_input_language", "ocr_model", "tesseract_lang", "keep_tables_as_one_chunk", "chunk_by_page", "handwriting_check", "follow_links", "max_depth", "max_documents", "root_dir", "copy_document", "guardrails_settings"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CollectionSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of guardrails_settings
        if self.guardrails_settings:
            _dict['guardrails_settings'] = self.guardrails_settings.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CollectionSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "max_tokens_per_chunk": obj.get("max_tokens_per_chunk"),
            "chunk_overlap_tokens": obj.get("chunk_overlap_tokens"),
            "gen_doc_summaries": obj.get("gen_doc_summaries") if obj.get("gen_doc_summaries") is not None else False,
            "gen_doc_questions": obj.get("gen_doc_questions") if obj.get("gen_doc_questions") is not None else False,
            "audio_input_language": obj.get("audio_input_language") if obj.get("audio_input_language") is not None else 'auto',
            "ocr_model": obj.get("ocr_model") if obj.get("ocr_model") is not None else 'auto',
            "tesseract_lang": obj.get("tesseract_lang"),
            "keep_tables_as_one_chunk": obj.get("keep_tables_as_one_chunk"),
            "chunk_by_page": obj.get("chunk_by_page"),
            "handwriting_check": obj.get("handwriting_check"),
            "follow_links": obj.get("follow_links"),
            "max_depth": obj.get("max_depth"),
            "max_documents": obj.get("max_documents"),
            "root_dir": obj.get("root_dir"),
            "copy_document": obj.get("copy_document"),
            "guardrails_settings": GuardrailsSettings.from_dict(obj["guardrails_settings"]) if obj.get("guardrails_settings") is not None else None
        })
        return _obj


